﻿-- Daily Global Check - Instance Lockouts plugin
-- Jadya EU-Well of Eternity
local addonName, addonTable = ...
local pluginicon = "Interface\\Icons\\INV_Helm_Suncrown_D_01"

-- template = {[ZONE],[NAME],[PREF],[SUFF],{{x,y},{x,y}},defaultmapID,[QUESTTYPE],[MAPICON],showfunc

local list = {
 ["Title"] = "Instance Lockouts",
 ["Icon"]  = pluginicon,
 ["Version"] = 1003,
 ["Order"] = {
              { -- page 1
               {GUILD_INTEREST_RAID.." ("..EXPANSION_NAME5..")"},
	           {PLAYER_DIFFICULTY1,
			    --"instance#1448#13", -- lrf hellfire
			    "instance#1228#14", -- normal hm
			    "instance#1205#14", -- normal brf
			    "instance#1448#14", -- normal hellfire
			   },
			   {ENCOUNTER_JOURNAL_SECTION_FLAG3,
			    --"instance#1205#13", -- lrf brf
			    "instance#1228#15", -- heroic hm
			    "instance#1205#15", -- heroic brf
			    "instance#1448#15", -- heroic hellfire
			   },
			   {ENCOUNTER_JOURNAL_SECTION_FLAG12,
			    --"instance#1228#13", -- lrf hm
			    "instance#1228#16", -- mythic hm
			    "instance#1205#16", -- mythic brf
			    "instance#1448#16", -- mythic hellfire
			   },
			  },
			  { -- page 2
			   {BUG_CATEGORY3.." ("..EXPANSION_NAME5..")"},
			   {ENCOUNTER_JOURNAL_SECTION_FLAG3,
			    "instance#1182#2", -- auchi
			    "instance#1175#2", -- bloodmaul
			    "instance#1208#2", -- grimrail
			    "instance#1195#2", -- docks
			    "instance#1176#2", -- shadowmoon
			    "instance#1209#2", -- skyreach
			    "instance#1279#2", -- everbloom
			    "instance#1358#2", -- upper
			   },
			   {ENCOUNTER_JOURNAL_SECTION_FLAG12,
			    "instance#1182#23", -- auchi
			    "instance#1175#23", -- bloodmaul
			    "instance#1208#23", -- grimrail
			    "instance#1195#23", -- docks
			    "instance#1176#23", -- shadowmoon
			    "instance#1209#23", -- skyreach
			    "instance#1279#23", -- everbloom
			    "instance#1358#23", -- upper
			   },
			  },
              { -- page 3
               {"Mists of Pandaria",
			    "instance#1008#all", -- mogu'shan
				"instance#1009#all", -- heart of fear
				"instance#996#all", -- terrace
				"instance#1098#all", -- throne of thunder
			   },
			   {"",
				"instance#1136#14", -- siege of orgrimmar
				"instance#1136#15", -- siege of orgrimmar
				"instance#1136#16", -- siege of orgrimmar
			   },
			   {DUNGEON_DIFFICULTY1,
			    "instance#962#2", -- gate
			    "instance#994#2", -- mogu
			    "instance#1001#2", -- scarlet h
			    "instance#1004#2", -- scarlet m
			    "instance#1007#2", -- scholo
			    "instance#959#2", -- shado
			    "instance#1011#2", -- niuz
			    "instance#961#2", -- brew
				"instance#960#2", -- jade
			   },
			  },
              { -- page 4
               {"Cataclysm",
			    "instance#967#all", -- dragon soul
				"instance#720#all", -- firelands
				"instance#754#all", -- throne
				"instance#671#all", -- bastion
				"instance#669#all", -- blackwing
				"instance#757#all", -- baradin hold
			   },
			   {DUNGEON_DIFFICULTY1,
			    "instance#645#2", -- blackrock
			    "instance#36#2", -- deadmines
			    "instance#670#2", -- grim batol
			    "instance#644#2", -- halls
			    "instance#755#2", -- lost
			    "instance#33#2", -- shadowfang
			    "instance#725#2", -- stonecore
			    "instance#657#2", -- vortex
				"instance#643#2", -- throne
				"instance#568#2", -- zul'aman
				"instance#859#2", -- zul'gurub
				"instance#940#2", -- hour
				"instance#939#2", -- well
				"instance#938#2", -- end time
			   },
			  },
              { -- page 5
               {"Wrath of the Lich King",
			    "instance#724#all", -- ruby
				"instance#631#all", -- icc
				"instance#649#all", -- toc
				"instance#603#all", -- ulduar
				"instance#249#all", -- onyxia
				"instance#615#all", -- obsidian
				"instance#616#all", -- eye
				"instance#533#all", -- naxx
				"instance#624#all", -- archa
			   },
			   {DUNGEON_DIFFICULTY1,
			    "instance#619#2", -- ahkn
			    "instance#601#2", -- azjo
			    "instance#600#2", -- drak
			    "instance#604#2", -- gund
			    "instance#599#2", -- halls of st
			    "instance#602#2", -- halls of lig
			    "instance#595#2", -- stratholme
			    "instance#576#2", -- nexus
				"instance#578#2", -- oculus
				"instance#608#2", -- violet
				"instance#650#2", -- trial
				"instance#574#2", -- utgarde keep
				"instance#575#2", -- utgarde pinnacle
				"instance#632#2", -- forge
				"instance#658#2", -- pit of saron
				"instance#668#2", -- halls of ref
			   },
			  },
			  { -- page 6
               {"Classic",
			    "instance#469#all", -- black
				"instance#409#all", -- molten
				"instance#531#all", -- temple
				"instance#509#all", -- ruins
			   },
               {"The Burning Crusade",
			    "instance#532#all", -- kara
				"instance#565#all", -- gruul
				"instance#544#all", -- maghter
				"instance#548#all", -- serpent
				"instance#534#all", -- hyjal
				"instance#550#all", -- eye
				"instance#564#all", -- black
				"instance#580#all", -- sunwell
			   },
			   {DUNGEON_DIFFICULTY1,
			    "instance#558#2", -- auchenai
			    "instance#543#2", -- hellfire
			    "instance#585#2", -- magi
			    "instance#557#2", -- mana
			    "instance#560#2", -- hills
			    "instance#556#2", -- sethekk
			    "instance#555#2", -- shadow
			    "instance#552#2", -- arca
				"instance#269#2", -- morass
				"instance#542#2", -- furnace
				"instance#553#2", -- bota
				"instance#554#2", -- mecha
				"instance#540#2", -- shatt
				"instance#547#2", -- slave
				"instance#545#2", -- steam
				"instance#546#2", -- under
			   },
			  },
			 },
 MultiCharsEnabled = true,
 }
			   
local questsdata
local function GenerateQuestsData()

 local difficulty_localization =
  {
   ["all"] = ALL,
   [1]     = PLAYER_DIFFICULTY1,
   [2]     = PLAYER_DIFFICULTY2,
   [3]     = RAID_DIFFICULTY1,
   [4]     = RAID_DIFFICULTY2,
   [5]     = RAID_DIFFICULTY3,
   [6]     = RAID_DIFFICULTY4,
   [13]    = PLAYER_DIFFICULTY3,
   [14]    = PLAYER_DIFFICULTY1,
   [15]    = PLAYER_DIFFICULTY2,
   [16]    = PLAYER_DIFFICULTY6,
   [23]    = PLAYER_DIFFICULTY6, -- Mythic 5 Player
   --[24]    = PLAYER_DIFFICULTY_TIMEWALKER,
  }
 -- creates a set of given difficulties for an instance
 local function createInstanceSet(zone, ID, loc, ...)
  local name = type(loc) == "string" and loc or (EJ_GetInstanceInfo(loc) or "Instance #"..loc)
  for i = 1, select("#", ...) do
   local diff = select(i, ...)
   questsdata["instance#"..ID.."#"..diff] = {zone, name, nil, " "..difficulty_localization[diff], nil,nil,"I"}
  end
 end
 
 local gor = GetMapNameByID(949) -- gorgrond
 local voeb = GetMapNameByID(937) -- vale
 local tanaris = GetMapNameByID(161)
 local searing = GetMapNameByID(28)
 questsdata = {}

 -- Warlords of Draenor Raids
 -- 6.2
 createInstanceSet(GetMapNameByID(945), 1448, 669, 13, 14, 15, 16) -- hellfire
 -- 6.0
 createInstanceSet(GetMapNameByID(950), 1228, 477, 13, 14, 15, 16) -- highmaul
 createInstanceSet(gor, 1205, 457, 13, 14, 15, 16) -- foundry

 -- Warlords of Draenor 5-man Dungeons 
 createInstanceSet(GetMapNameByID(946), 1182, 547, 2, 23) -- auchi
 createInstanceSet(GetMapNameByID(941), 1175, 385, 2, 23) -- bloodmaul
 createInstanceSet(gor, 1208, 536, 2, 23) -- grimrail
 createInstanceSet(gor, 1195, 558, 2, 23) -- docks
 createInstanceSet(GetMapNameByID(947), 1176, 537, 2, 23) -- shadowmoon
 createInstanceSet(GetMapNameByID(948), 1209, 476, 2, 23) -- skyreach
 createInstanceSet(gor, 1279, 556, 2, 23) -- everbloom
 createInstanceSet(searing, 1358, 559, 2, 23) -- upper
 
 -- Mists of Pandaria Raids
 createInstanceSet(voeb, 1136, 369, 14, 15, 16) -- siege of orgrimmar (flex)
 createInstanceSet(GetMapNameByID(809), 1008, 317, "all") -- mogu'shan vaults
 createInstanceSet(GetMapNameByID(858), 1009, 330, "all") -- heart of fear
 createInstanceSet(GetMapNameByID(873), 996, 320, "all") -- terrace
 createInstanceSet(GetMapNameByID(928), 1098, 362, "all") -- throne of thunder
 
 -- Mists of Pandaria 5-man Dungeons
 createInstanceSet(voeb, 962, 303, 2) -- gate of the setting sun
 createInstanceSet(voeb, 994, 321, 2) -- mogu'shan palace
 createInstanceSet(GetMapNameByID(20), 1001, 311, 2) -- scarlet halls
 createInstanceSet(GetMapNameByID(20), 1004, 316, 2) -- scarlet monastery
 createInstanceSet(GetMapNameByID(22), 1007, 246, 2) -- scholo
 createInstanceSet(GetMapNameByID(809), 959, 312, 2) -- shadopan
 createInstanceSet(GetMapNameByID(810), 1011, 324, 2) -- niuzao
 createInstanceSet(GetMapNameByID(807), 961, 302, 2) -- brewery
 createInstanceSet(GetMapNameByID(806), 960, 313, 2) -- jade serpent

 -- Cataclysm
 createInstanceSet(tanaris, 967, 187, "all") -- dragon soul
 createInstanceSet(GetMapNameByID(606), 720, 78, "all") -- firelands
 createInstanceSet(GetMapNameByID(720), 754, 74, "all") -- throne
 createInstanceSet(GetMapNameByID(770), 671, 72, "all") -- bastion
 createInstanceSet(searing, 669, 73, "all") -- blackwing
 createInstanceSet(GetMapNameByID(708), 757, 75, "all") -- baradin hold
 
 -- Cataclysm 5-man Dungeons
 createInstanceSet(searing, 645, 66, 2) -- blackrock
 createInstanceSet(GetMapNameByID(39), 36, 63, 2) -- deadmines
 createInstanceSet(GetMapNameByID(700), 670, 71, 2) -- grim batol
 createInstanceSet(GetMapNameByID(495), 644, 70, 2) -- halls of orig
 createInstanceSet(GetMapNameByID(720), 755, 69, 2) -- lost city
 createInstanceSet(GetMapNameByID(21), 33, 64, 2) -- shadowfang
 createInstanceSet(GetMapNameByID(640), 725, 67, 2) -- stonecore
 createInstanceSet(GetMapNameByID(720), 657, 68, 2) -- vortex
 createInstanceSet(GetMapNameByID(614), 643, 65, 2) -- throne
 createInstanceSet(GetMapNameByID(37), 568, 77, 2) -- zul'aman
 createInstanceSet(GetMapNameByID(37), 859, 76, 2) -- zul'gurub
 createInstanceSet(tanaris, 940, 186, 2) -- hour of twi
 createInstanceSet(tanaris, 939, 185, 2) -- well
 createInstanceSet(tanaris, 938, 184, 2) -- end time
 
  -- Wotlk
 createInstanceSet(GetMapNameByID(488), 724, GetMapNameByID(609), "all") -- ruby sanctum
 createInstanceSet(GetMapNameByID(492), 631, GetMapNameByID(604), "all") -- icc
 createInstanceSet(GetMapNameByID(492), 649, GetMapNameByID(543), "all") -- toc
 createInstanceSet(GetMapNameByID(495), 603, GetMapNameByID(529), "all") -- ulduar
 createInstanceSet(GetMapNameByID(851), 249, GetMapNameByID(718), "all") -- onyxia
 createInstanceSet(GetMapNameByID(488), 615, GetMapNameByID(531), "all") -- obsidian
 createInstanceSet(GetMapNameByID(486), 616, GetMapNameByID(527), "all") -- eye
 createInstanceSet(GetMapNameByID(488), 533, GetMapNameByID(535), "all") -- naxxramas
 createInstanceSet(GetMapNameByID(501), 624, GetMapNameByID(532), "all") -- archavon

 -- Wotlk 5-man Dungeons
 createInstanceSet(GetMapNameByID(488), 619, 271, 2) -- ahkn
 createInstanceSet(GetMapNameByID(488), 601, 272, 2) -- azjo
 createInstanceSet(GetMapNameByID(496), 600, 273, 2) -- drak
 createInstanceSet(GetMapNameByID(496), 604, 274, 2) -- gund
 createInstanceSet(GetMapNameByID(495), 599, 277, 2) -- halls of st
 createInstanceSet(GetMapNameByID(495), 602, 275, 2) -- halls of lig
 createInstanceSet(tanaris, 595, 279, 2) -- stratholme
 createInstanceSet(GetMapNameByID(486), 576, 281, 2) -- nexus
 createInstanceSet(GetMapNameByID(486), 578, 282, 2) -- oculus
 createInstanceSet(GetMapNameByID(504), 608, 283, 2) -- violet
 createInstanceSet(GetMapNameByID(492), 650, 284, 2) -- trial
 createInstanceSet(GetMapNameByID(491), 574, 285, 2) -- utgarde keep
 createInstanceSet(GetMapNameByID(491), 575, 286, 2) -- utgarde pinnacle
 createInstanceSet(GetMapNameByID(604), 632, 280, 2) -- forge
 createInstanceSet(GetMapNameByID(604), 658, 278, 2) -- pit of saron
 createInstanceSet(GetMapNameByID(604), 668, 276, 2) -- halls of ref
 
 -- The Burning Crusade
 createInstanceSet(GetMapNameByID(32), 532, GetAchievementCriteriaInfo(1286,7), "all") -- karazhan
 createInstanceSet(GetMapNameByID(475), 565, GetAchievementCriteriaInfo(1286,2), "all") -- gruul
 createInstanceSet(GetMapNameByID(465), 544, GetAchievementCriteriaInfo(1286,5), "all") -- maghter
 createInstanceSet(GetMapNameByID(467), 548, GetAchievementCriteriaInfo(1286,1), "all") -- serpent
 createInstanceSet(tanaris, 534, GetAchievementCriteriaInfo(1286,3), "all") -- hyjal
 createInstanceSet(GetMapNameByID(479), 550, GetAchievementCriteriaInfo(1286,6), "all") -- eye
 createInstanceSet(GetMapNameByID(473), 564, GetAchievementCriteriaInfo(1286,8), "all") -- black
 createInstanceSet(GetMapNameByID(499), 580, GetAchievementCriteriaInfo(1286,4), "all") -- sunwell
 
 -- The Burning Crusade 5-man Dungeons
 createInstanceSet(GetMapNameByID(478), 558, 247, 2) -- auchenai
 createInstanceSet(GetMapNameByID(465), 543, 248, 2) -- hellfire
 createInstanceSet(GetMapNameByID(499), 585, 249, 2) -- magister
 createInstanceSet(GetMapNameByID(478), 557, 250, 2) -- mana tombs
 createInstanceSet(tanaris, 560, 251, 2) -- hillsbrad
 createInstanceSet(GetMapNameByID(478), 556, 252, 2) -- sethekk
 createInstanceSet(GetMapNameByID(478), 555, 253, 2) -- shadow
 createInstanceSet(GetMapNameByID(479), 552, 254, 2) -- the arcatraz
 createInstanceSet(tanaris, 269, 255, 2) -- morass
 createInstanceSet(GetMapNameByID(465), 542, 256, 2) -- furnace
 createInstanceSet(GetMapNameByID(479), 553, 257, 2) -- botanica
 createInstanceSet(GetMapNameByID(479), 554, 258, 2) -- mechanar
 createInstanceSet(GetMapNameByID(465), 540, 259, 2) -- shattered
 createInstanceSet(GetMapNameByID(467), 547, 260, 2) -- slave
 createInstanceSet(GetMapNameByID(467), 545, 261, 2) -- steamvault
 createInstanceSet(GetMapNameByID(467), 546, 262, 2) -- underbog
 
 -- Classic
 createInstanceSet(searing, 469, GetAchievementCriteriaInfo(1285,1), "all") -- blackwing
 createInstanceSet(searing, 409, GetAchievementCriteriaInfo(1285,2), "all") -- molten
 createInstanceSet(GetMapNameByID(261), 531, GetAchievementCriteriaInfo(1285,3), "all") -- temple
 createInstanceSet(GetMapNameByID(261), 509, GetAchievementCriteriaInfo(1285,4), "all") -- ruins
end

local function Initialize()
 if not DailyGlobalCheck then return end
 DailyGlobalCheck:LoadPlugin(list, questsdata)
end

local initialized = false
local eventframe = CreateFrame("FRAME")
eventframe:RegisterEvent("VARIABLES_LOADED")
eventframe:RegisterEvent("ADDON_LOADED")
local function eventhandler(self, event, ...)
 if event == "ADDON_LOADED" and ... == addonName then
  if not DailyGlobalCheck then return end
  GenerateQuestsData()
  Initialize()
  initialized = true
 elseif event == "VARIABLES_LOADED" then
  if not initialized then Initialize() end
 end
end
eventframe:SetScript("OnEvent", eventhandler)